<?php

namespace app\index\controller;

use app\common\controller\Frontend;
use think\Session;
use think\Lang;
use think\Db;
use think\facade\Request;

class Index extends Frontend
{

    protected $noNeedLogin = '*';
    protected $noNeedRight = '*';
    protected $layout = '';
    protected $lang = '';
    protected $city = '';
    protected $html_lang = [];
    // 天气api账号权限
    protected $appid = '16787288';
    protected $appsecret = '2FfdRJK8';

    public function _initialize()
    {
        parent::_initialize();
        $this->view->assign('title', 'my pagetitle');
        $this->lang = $this->request->param('lang');
        $this->city = $this->request->param('city');
        if (!empty($this->lang)) {
            Session::set('lang', $this->lang);
        } else {
            if (!empty(Session::get('lang'))) {
                $this->lang = Session::get('lang');
            } else {
                $this->lang = 'en';
            }
        }
        Session::set('lang', $this->lang);
        if (!empty($this->city)) {
            Session::set('city', $this->city);
            $this->city = Session::get('city');
        } else {
            if (!empty(Session::get('lang'))) {
                $this->city = Session::get('city');
            }
        }


        $this->view->assign('lang', $this->lang);
        $this->view->assign('city', $this->city);
        //获取网页语言包
        $this->html_lang = Lang::load(APP_PATH . '/index/lang/weather/' . $this->lang . '.php');
        $this->view->assign('html_lang', $this->html_lang);
    }

    private function airtips($amount)
    {
        if ($amount <= 50) {
            $air_tips = '空气质量令人满意，基本无空气污染，对健康没有危害';
        } elseif ($amount <= 100) {
            $air_tips = '除少数对某些污染物特别敏感的人群外，不会对人体健康产生危害';
        } elseif ($amount <= 150) {
            $air_tips = '敏感人群症状会有轻度加剧，对健康人群没有明显影响';
        } elseif ($amount <= 200) {
            $air_tips = '敏感人群症状进一步加剧，可能对健康人群的心脏、呼吸系统有影响';
        } elseif ($amount <= 300) {
            $air_tips = '空气状况很差，会对每个人的健康都产生比较严重的危害';
        } else {
            $air_tips = '空气状况极差，所有人的健康都会受到严重危害';
        }
        return $air_tips;
    }

    private function getweather()
    {
        $yikeurl = array('http://pear.tianqiapis.com/', 'http://v0.tianqiapi.com/');
        $ip = null;
        if (empty($this->city)) {
            $ip = $this->request->server('REMOTE_ADDR');
            $cache_pre = 'weather_' . $this->lang . '_' . $ip;
            $url = $yikeurl[rand(0,1)] . '?version=day&unit=m&language=' . $this->lang . '&ip=' . $ip . '&appid=' . $this->appid . '&appsecret=' . $this->appsecret;
        } else {
            $cache_pre = 'weather_' . $this->lang . '_' . md5($this->city);
            $url = $yikeurl[rand(0,1)] . '?version=day&unit=m&language=' . $this->lang . '&query=' . urlencode($this->city) . '&appid=' . $this->appid . '&appsecret=' . $this->appsecret;
        }
        $json = cache($cache_pre);
        if (empty($json)) {
            $data = file_get_contents($url);
            $json = json_decode($data, true);
            if (!empty($json['day']['phrase'])) {
                cache($cache_pre, $json, ['expire' => 7200]);
                Session::set('city', $json['city']);
                $this->view->assign('city', $json['city']);
                $this->city = $json['city'];
            }
        }
        return $json;
    }

    /**
     * 设置语言
     */
    public function lang()
    {
        $this->lang = $this->request->param('lang');
        if (!empty($this->lang)) {
            Session::set('lang', $this->lang);
        }
        Session::set('lang', $this->lang);
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_index'], $this->view->__get('site')['name']));
        // ./pagetitle
        return $this->view->fetch('index');
    }

    public function ajaxindex()
    {
        $json = $this->getweather();
        echo json_encode($json);
        exit;
    }

    public function index()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_index'], $this->view->__get('site')['name']));
        // ./pagetitle
        return $this->view->fetch();
    }

    public function today()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_today'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        // 空气提示
        //$air_tips = $this->airtips(intval($json['day']['aqi']['AIR']['amount']));
        //$this->view->assign('air_tips', $air_tips);
        //print_r($json);exit;
        //View::share('weather', $json);
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function tomorrow()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_tomorrow'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        unset($json['month'][0]);
        unset($json['month'][2]);
        unset($json['month'][3]);
        unset($json['month'][4]);
        unset($json['month'][5]);
        unset($json['month'][6]);
        unset($json['month'][7]);
        unset($json['month'][8]);
        unset($json['month'][9]);
        unset($json['month'][10]);
        unset($json['month'][11]);
        unset($json['month'][12]);
        unset($json['month'][13]);
        unset($json['month'][14]);
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function air()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_air'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function month()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_month'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function week()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_week'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        unset($json['month'][7]);
        unset($json['month'][8]);
        unset($json['month'][9]);
        unset($json['month'][10]);
        unset($json['month'][11]);
        unset($json['month'][12]);
        unset($json['month'][13]);
        unset($json['month'][14]);
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function hours()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_hours'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $json = $this->getweather();
        $this->view->assign('weather', $json);
        return $this->view->fetch();
    }

    public function checkcity()
    {
        $slang = Session::get('lang');
        $query = $this->request->request("city");
        if (empty($slang) || empty($query)) {
            echo json_encode(array(
                'errcode' => 100,
                'errmsg' => '参数不完整',
            ));
            exit;
        }
        $this->city = $query;
        $data = $this->getweather();
        echo json_encode($data, JSON_UNESCAPED_UNICODE);
        exit;
        $url = 'http://pitaya.tianqiapis.com/?version=day&unit=m&language=' . $slang . '&query=' . urlencode($query) . '&appid=' . $this->appid . '&appsecret=' . $this->appsecret;
        $data = file_get_contents($url);
        $json = json_decode($data, true);
        if (!empty($json['day']['phrase'])) {
            cache('weather_' . $slang . '_' . md5($query), $json, ['expire' => 7200]);
            Session::set('city', $json['city']);
            $this->view->assign('city', $json['city']);
            $this->city = $json['city'];
            echo $data;
            exit;
        } else {
            echo $data;exit;
            echo json_encode(array(
                'errcode' => 100,
                'errmsg' => '没有搜索到城市',
            ));
            exit;
        }
    }

    public function country()
    {
        // pagetitle
        $this->view->assign('pagetitle', sprintf($this->html_lang['title_month'], $this->city, $this->view->__get('site')['name']));
        // ./pagetitle
        $country = $this->request->param('city');
        $this->view->assign('country', $country);
        //echo 'SELECT * FROM fa_cityall WHERE countryEn=\'' . $country . '\' ORDER BY countryEn';
        //$list = Db::query('SELECT * FROM fa_cityall WHERE countryEn=\'' . $country . '\' ORDER BY countryEn');
        //var_dump($list);exit;
        $list = Db::name('cityall')->where('countryEn', $country)->order('cityEn ASC')->select();
        //print_r($list);
        $this->view->assign('list', $list);
        return $this->view->fetch();
    }

}
